/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import CustomAnimateChild from "./CustomAnimateChild";
export interface DataProps {
    appearAnimate?: boolean;
    mode?: "in" | "out" | "in-out";
    leaveStyle?: React.CSSProperties;
    enterStyle?: React.CSSProperties;
    speed?: number;
    transitionTimingFunction?: string;
    enterDelay?: number;
    leaveDelay?: number;
    component?: any;
    useWrapper?: boolean;
    wrapperStyle?: React.CSSProperties;
    style?: React.CSSProperties;
}
export interface CustomAnimateProps extends DataProps {
}
export declare class CustomAnimate extends React.Component<CustomAnimateProps> {
    static defaultProps: CustomAnimateProps;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    customAnimateChildArray: CustomAnimateChild[];
    setLeaveStyle: () => void;
    setEnterStyle: () => void;
    render(): JSX.Element;
}
declare const slideBottomInProps: CustomAnimateProps;
declare const slideTopInProps: CustomAnimateProps;
declare const slideLeftInProps: CustomAnimateProps;
declare const slideRightInProps: CustomAnimateProps;
declare const scaleInProps: CustomAnimateProps;
declare const fadeInProps: CustomAnimateProps;
export { fadeInProps, scaleInProps, slideTopInProps, slideBottomInProps, slideLeftInProps, slideRightInProps };
export default CustomAnimate;
