/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import TextBox from "../TextBox";
import ListView from "../ListView";
export interface DataProps {
    listSource?: React.ReactNode[];
    onChangeValue?: (value: string) => void;
    searchAction?: (value?: string) => void;
    iconSize?: number;
    background?: string;
    placeholder?: string;
}
export interface AutoSuggestBoxProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface AutoSuggestBoxState {
    typing?: boolean;
    showListSource?: boolean;
    focusListSourceIndex?: number;
}
export declare class AutoSuggestBox extends React.Component<AutoSuggestBoxProps, AutoSuggestBoxState> {
    static defaultProps: AutoSuggestBoxProps;
    state: AutoSuggestBoxState;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    textBox: TextBox;
    listView: ListView;
    inputTimer: any;
    componentDidMount(): void;
    componentWillUnmount(): void;
    checkLayerClick: (e: Event) => void;
    checkLayerKeydown: (e: KeyboardEvent) => void;
    toggleShowListSource: (showListSource?: any) => void;
    showListSource: () => void;
    handleChange: (e?: any) => void;
    getValue: () => string;
    setValue: (value: string) => string;
    handleButtonAction: (e: React.MouseEvent<HTMLInputElement>) => void;
    handleChooseItem: (index: number) => void;
    handleInputKeyDown: (e: React.KeyboardEvent<HTMLDivElement>) => void;
    render(): JSX.Element;
}
export default AutoSuggestBox;
