/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
export interface DataProps {
    borderSize?: string;
    hoverStyle?: React.CSSProperties;
    activeStyle?: React.CSSProperties;
    icon?: string;
    iconStyle?: React.CSSProperties;
    iconPosition?: "left" | "right";
    disabled?: boolean;
    tooltip?: React.ReactElement<any> | string;
    background?: string;
}
export interface ButtonProps extends DataProps, React.HTMLAttributes<HTMLButtonElement> {
}
export declare class Button extends React.Component<ButtonProps> {
    static defaultProps: ButtonProps;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    refs: {
        container: HTMLButtonElement;
    };
    render(): JSX.Element;
}
export default Button;
