/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
export interface DataProps {
    defaultChecked?: true | false | null;
    onCheck?: (checked?: boolean) => void;
    labelPosition?: "left" | "right";
    background?: string;
    size?: string | number;
    label?: string;
    disabled?: boolean | string;
}
export interface CheckBoxProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface CheckBoxState {
    checked?: boolean;
}
export declare class CheckBox extends React.Component<CheckBoxProps, CheckBoxState> {
    static defaultProps: CheckBoxProps;
    state: CheckBoxState;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    rootElm: HTMLDivElement;
    componentWillReceiveProps(nextProps: CheckBoxProps): void;
    toggleChecked: (e?: React.SyntheticEvent<HTMLDivElement>) => void;
    handleClick: (e: React.MouseEvent<HTMLDivElement>) => void;
    render(): JSX.Element;
}
export default CheckBox;
