/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import AddBlurEvent from "../common/AddBlurEvent";
export interface DataProps {
    contentStyle?: React.CSSProperties;
    content?: string;
    contentNode?: React.ReactNode;
    primaryCommands?: React.ReactElement<any>[];
    secondaryCommands?: React.ReactElement<any>[];
    labelPosition?: "right" | "bottom" | "collapsed";
    expanded?: boolean;
    flowDirection?: "row-reverse" | "row";
    isMinimal?: boolean;
    verticalPosition?: "top" | "bottom";
    background?: string;
}
export interface CommandBarProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface CommandBarState {
    currExpanded?: boolean;
}
export declare class CommandBar extends React.Component<CommandBarProps, CommandBarState> {
    static defaultProps: CommandBarProps;
    state: CommandBarState;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    rootElm: HTMLDivElement;
    addBlurEvent: AddBlurEvent;
    componentWillReceiveProps(nextProps: CommandBarProps): void;
    addBlurEventMethod: () => void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    toggleExpanded: (currExpanded?: any) => void;
    render(): JSX.Element;
}
export default CommandBar;
