/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import AddBlurEvent from "../common/AddBlurEvent";
import RenderToBody from "../RenderToBody";
export interface DataProps {
    statusBarTitle?: string;
    showCloseButton?: boolean;
    title?: string;
    content?: string;
    contentNode?: React.ReactNode;
    primaryButtonText?: string;
    secondaryButtonText?: string;
    defaultShow?: boolean;
    closeButtonAction?: (e: React.MouseEvent<HTMLButtonElement>) => void;
    primaryButtonAction?: (e: React.MouseEvent<HTMLButtonElement>) => void;
    secondaryButtonAction?: (e: React.MouseEvent<HTMLButtonElement>) => void;
    onCloseDialog?: () => void;
    background?: string;
    padding?: number;
}
export interface ContentDialogProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface ContentDialogState {
    showDialog?: boolean;
}
export declare class ContentDialog extends React.Component<ContentDialogProps, ContentDialogState> {
    static defaultProps: ContentDialogProps;
    state: ContentDialogState;
    addBlurEvent: AddBlurEvent;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    renderToBody: RenderToBody;
    rootElm: HTMLDivElement;
    shouldComponentUpdate(nextProps: ContentDialogProps, nextState: ContentDialogState): boolean;
    addBlurEventMethod: () => void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    containerMouseEnterHandle: (e: React.MouseEvent<HTMLDivElement>) => void;
    containerMouseLeaveHandle: (e: React.MouseEvent<HTMLDivElement>) => void;
    closeDialog: () => void;
    render(): JSX.Element;
}
export default ContentDialog;
