/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import AddBlurEvent from "../common/AddBlurEvent";
export interface DataProps {
    defaultShow?: boolean;
    isControlled?: boolean;
    contentStyle?: React.CSSProperties;
    contentEnterStyle?: React.CSSProperties;
    contentLeaveStyle?: React.CSSProperties;
    onCloseDialog?: () => void;
}
export interface DialogProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface DialogState {
    showDialog?: boolean;
}
export declare class Dialog extends React.Component<DialogProps, DialogState> {
    static defaultProps: DialogProps;
    state: DialogState;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    rootElm: HTMLDivElement;
    addBlurEvent: AddBlurEvent;
    componentWillReceiveProps(nextProps: DialogProps): void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    toggleShow: (showDialog?: boolean) => void;
    addBlurEventMethod: () => void;
    render(): JSX.Element;
}
export default Dialog;
