/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import AddBlurEvent from "../common/AddBlurEvent";
export interface DataProps {
    defaultValue?: string | string[];
    values?: string[];
    onChangeValue?: (value: string) => void;
    background?: string;
    itemWidth?: number;
    itemHeight?: number;
    padding?: number;
    wrapperAttributes?: React.HTMLAttributes<HTMLDivElement>;
    itemAttributes?: React.HTMLAttributes<HTMLDivElement>;
}
export interface DropDownMenuProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface DropDownMenuState {
    showList?: boolean;
    currentValue?: string | string[];
    currentValues?: string[];
}
export declare class DropDownMenu extends React.Component<DropDownMenuProps, DropDownMenuState> {
    static defaultProps: DropDownMenuProps;
    state: DropDownMenuState;
    addBlurEvent: AddBlurEvent;
    rootElm: HTMLDivElement;
    wrapperElm: HTMLDivElement;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    componentWillReceiveProps(nextProps: DropDownMenuProps): void;
    addBlurEventMethod: () => void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    toggleShowList: (currentValue: string) => void;
    getValue: () => string | string[];
    render(): JSX.Element;
}
export default DropDownMenu;
