/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
export interface ExpandedItem {
    iconNode?: React.ReactElement<any>;
    title?: string;
    onClick?: (e?: React.MouseEvent<HTMLAnchorElement>) => void;
    href?: string;
    focusColor?: string;
}
export interface DataProps {
    isFloatRight?: boolean;
    initWidth?: number;
    expandedWidth?: number;
    topNode?: React.ReactElement<any> | React.ReactElement<any>[];
    bottomNode?: React.ReactElement<any> | React.ReactElement<any>[];
    expandedItems?: ExpandedItem[];
    focusItemIndex?: number;
    onFocusItem?: (itemIndex?: number) => void;
}
export interface FloatNavProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface FloatNavState {
    currFocusItemIndex?: number;
    hoverItem?: number;
    hoverIndexArray?: boolean[];
}
export declare class FloatNav extends React.Component<FloatNavProps, FloatNavState> {
    static defaultProps: FloatNavProps;
    state: FloatNavState;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    componentWillReceiveProps(nextProps: FloatNavProps): void;
    shouldComponentUpdate(nextProps: FloatNavProps, nextState: FloatNavState): boolean;
    focusIndex: (currFocusItemIndex: number) => void;
    getFocusIndex: () => number;
    getItems: () => ExpandedItem[];
    render(): JSX.Element;
}
export default FloatNav;
