/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
export interface DataProps {
    verticalPosition?: "top" | "bottom" | "center";
    horizontalPosition?: "left" | "right" | "center";
    show?: boolean;
    margin?: number;
    isControlled?: boolean;
    autoClose?: boolean;
    autoCloseTimeout?: number;
    enterDelay?: number;
}
export interface FlyoutContentProps extends DataProps, React.HTMLAttributes<HTMLSpanElement> {
}
export interface FlyoutContentState {
    showFlyoutContent?: boolean;
}
declare class FlyoutContent extends React.Component<FlyoutContentProps, FlyoutContentState> {
    static defaultProps: FlyoutContentProps;
    state: FlyoutContentState;
    rootElm: HTMLDivElement;
    autoHideTimer: any;
    hideTimer: any;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    componentWillReceiveProps(nextProps: FlyoutContentProps): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    showFlyoutContent: () => void;
    hideFlyoutContent: () => void;
    toggleShowFlyoutContent: (showFlyoutContent?: boolean) => void;
    getStaticStyle: (showFlyoutContent?: boolean) => React.CSSProperties;
    getDynamicStyle: (unit?: string) => React.CSSProperties;
    handelMouseEnter: (e: React.MouseEvent<HTMLDivElement>) => void;
    handelMouseLeave: (e: React.MouseEvent<HTMLDivElement>) => void;
    render(): JSX.Element;
}
export default FlyoutContent;
