/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
declare const icons: {
    [key: string]: string;
};
export interface DataProps {
    size?: number;
    hoverStyle?: React.CSSProperties;
    activeStyle?: React.CSSProperties;
    children?: React.ReactNode;
    useSVGElement?: boolean;
}
export interface IconProps extends DataProps, React.HTMLAttributes<HTMLSpanElement> {
}
export interface IconState {
    hovered?: boolean;
}
export declare class Icon extends React.Component<IconProps, IconState> {
    static defaultProps: IconProps;
    state: IconState;
    context: {
        theme: ReactUWP.ThemeType;
    };
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    handleMouseEnter: (e: React.MouseEvent<HTMLSpanElement>) => void;
    handleMouseLeave: (e: React.MouseEvent<HTMLSpanElement>) => void;
    render(): JSX.Element;
}
export { icons };
export default Icon;
