/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
export interface DataProps {
    useLazyLoad?: boolean;
    useDivContainer?: boolean;
    once?: boolean;
    offset?: number | number[];
    scroll?: boolean;
    resize?: boolean;
    overflow?: boolean;
    debounce?: boolean | number;
    throttle?: boolean | number;
    placeholder?: React.ReactElement<any> | React.ReactNode;
    src?: string;
    height?: string | number;
}
export interface ImageProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface ImageState {
    showEmptyImage?: boolean;
}
export declare class Image extends React.Component<ImageProps, ImageState> {
    static defaultProps: ImageProps;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    state: ImageState;
    errorHandler: (e: any) => void;
    render(): any;
}
export default Image;
