/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import AddBlurEvent from "../common/AddBlurEvent";
export interface DataProps {
    icon?: string;
    label?: string;
    children?: MenuItem | MenuItem[] | React.ReactElement<any> | React.ReactElement<any>[];
    defaultExpanded?: boolean;
    itemWidth?: number;
    itemHeight?: number;
    hoverStyle?: React.CSSProperties;
}
export interface AnyAttributes {
    [key: string]: any;
}
export interface MenuItemProps extends DataProps, AnyAttributes {
}
export interface MenuItemState {
    expanded?: boolean;
}
export declare class MenuItem extends React.Component<MenuItemProps, MenuItemState> {
    static defaultProps: MenuItemProps;
    state: MenuItemState;
    addBlurEvent: AddBlurEvent;
    rootElm: HTMLDivElement;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    componentWillReceiveProps(nextProps: MenuItemProps): void;
    addBlurEventMethod: () => void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    toggleExpanded: (expanded?: any) => void;
    render(): JSX.Element;
}
export default MenuItem;
