/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import MenuItem from "./MenuItem";
export { MenuItem };
export interface DataProps {
    children?: React.ReactNode[] | any;
    menuItemWidth?: number;
    menuItemHeight?: number;
    menuItemHoverStyle?: React.CSSProperties;
}
export interface MenuItemProps {
    icon?: string;
    label?: string;
    children?: MenuItem | MenuItem[];
    defaultExpanded?: boolean;
    itemWidth?: number;
    itemHeight?: number;
    hoverStyle?: React.CSSProperties;
}
export interface AnyAttributes {
    [key: string]: any;
}
export interface MenuProps extends DataProps, AnyAttributes {
}
export interface MenuState {
}
export declare class Menu extends React.Component<MenuProps, MenuState> {
    static defaultProps: MenuProps;
    state: MenuState;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    render(): JSX.Element;
}
export default Menu;
