/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import AddBlurEvent from "../common/AddBlurEvent";
import SplitViewCommand from "../SplitViewCommand";
export { SplitViewCommand };
export interface NavigationComplexNode {
    default?: React.ReactNode;
    expanded?: React.ReactNode;
}
export declare type NavigationNode = SplitViewCommand | React.ReactNode;
export interface DataProps {
    background?: string;
    initWidth?: number;
    expandedWidth?: number;
    defaultExpanded?: boolean;
    topIcon?: React.ReactElement<any>;
    isControlled?: boolean;
    navigationTopNodes?: Array<NavigationNode | NavigationComplexNode>;
    navigationBottomNodes?: Array<NavigationNode | NavigationComplexNode>;
    displayMode?: "overlay" | "compact" | "minimal";
    pageTitle?: string;
    paneStyle?: React.CSSProperties;
    isTenFt?: boolean;
    autoResize?: boolean;
    focusNavigationNodeIndex?: number;
}
export interface NavigationViewProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface NavigationViewState {
    expanded?: boolean;
    focusNodeIndex?: number;
    currDisplayMode?: "overlay" | "compact" | "minimal";
    currInitWidth?: number;
}
export declare class NavigationView extends React.Component<NavigationViewProps, NavigationViewState> {
    static defaultProps: NavigationViewProps;
    state: NavigationViewState;
    addBlurEvent: AddBlurEvent;
    paneElm: HTMLDivElement;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    componentWillMount(): void;
    addBlurEventMethod: () => void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    shouldComponentUpdate(nextProps: NavigationViewProps, nextState: NavigationViewState, nextContext: {
        theme: ReactUWP.ThemeType;
    }): boolean;
    componentWillUnmount(): void;
    autoResize: (e?: Event) => void;
    updateProps2State: ({defaultExpanded}: NavigationViewProps) => void;
    toggleExpanded: (expanded?: boolean) => void;
    getNewNodeProps: (currNode: any, index: number, expanded?: boolean, haveExpandedNode?: boolean) => {
        key: string;
        showLabel: boolean;
        visited: boolean;
        onClick: (e: any) => void;
    };
    render(): JSX.Element;
}
export default NavigationView;
