/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import TextBox from "../TextBox";
export interface DataProps {
    defaultShowPassword?: boolean;
    onChangeValue?: (value: string) => void;
    passwordBoxHeight?: number;
    placeholder?: string;
}
export interface PasswordBoxProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface PasswordBoxState {
    showPassword?: boolean;
}
export declare class PasswordBox extends React.Component<PasswordBoxProps, PasswordBoxState> {
    static defaultProps: PasswordBoxProps;
    state: PasswordBoxState;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    textBox: TextBox;
    handleChange: (e?: any) => void;
    getValue: () => string;
    setValue: (value: string) => string;
    toggleShowPassword: (showPassword?: any) => void;
    render(): JSX.Element;
}
export default PasswordBox;
