/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
export interface DataProps {
    defaultRating?: number;
    maxRating?: number;
    icon?: string;
    iconStyle?: React.CSSProperties;
    iconRatedStyle?: React.CSSProperties;
    onChangeRating?: (rating?: number) => void;
    label?: string;
    isReadOnly?: boolean;
    iconPadding?: number;
}
export interface RatingControlProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface RatingControlState {
    currRating?: number;
}
export declare class RatingControl extends React.Component<RatingControlProps, RatingControlState> {
    static defaultProps: RatingControlProps;
    rootElm: HTMLDivElement;
    state: RatingControlState;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    componentWillReceiveProps(nextProps: RatingControlProps): void;
    handleRationClick: (e: React.MouseEvent<HTMLSpanElement>, index: number) => void;
    render(): JSX.Element;
}
export default RatingControl;
