/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import CustomAnimate from "../Animate/CustomAnimate";
export interface DataProps {
    speed?: number;
    leaveStyle?: React.CSSProperties;
    enterStyle?: React.CSSProperties;
    transitionTimingFunction?: string;
    children?: React.ReactElement<any> | React.ReactElement<any>[];
    topOffset?: number;
    bottomOffset?: number;
    useWrapper?: boolean;
    wrapperStyle?: React.CSSProperties;
}
export interface ScrollRevealProps extends DataProps {
    style?: React.CSSProperties;
}
export declare class ScrollReveal extends React.Component<ScrollRevealProps> {
    static defaultProps: ScrollRevealProps;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    customAnimate: CustomAnimate;
    rootElm: HTMLElement;
    animated: boolean;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    setEnterStyle: () => void;
    setLeaveStyle: () => void;
    render(): JSX.Element;
}
export default ScrollReveal;
export { fadeInProps, scaleInProps, slideTopInProps, slideBottomInProps, slideLeftInProps, slideRightInProps } from "../Animate/CustomAnimate";
