/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import Tab, { DataProps as TabProps } from "./Tab";
export { Tab, TabProps };
export interface DataProps {
    defaultFocusTabIndex?: number;
    tabTitleStyle?: React.CSSProperties;
    tabTitleFocusStyle?: React.CSSProperties;
    tabStyle?: React.CSSProperties;
    renderTitle?: (title?: string) => React.ReactNode;
    useAnimate?: boolean;
    animateMode?: "in" | "out" | "in-out";
    animateSpeed?: number;
    animateEnterStyle?: React.CSSProperties;
    animateLeaveStyle?: React.CSSProperties;
}
export interface TabsProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface TabsState {
    tabFocusIndex?: number;
}
export declare class Tabs extends React.Component<TabsProps, TabsState> {
    static defaultProps: TabsProps;
    state: TabsState;
    componentWillReceiveProps(nextProps: TabsProps): void;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    render(): JSX.Element;
}
export default Tabs;
