/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
export interface DataProps {
    hoverStyle?: React.CSSProperties;
    focusStyle?: React.CSSProperties;
    textBoxStyle?: React.CSSProperties;
    onChangeValue?: (value: string) => void;
    leftNode?: React.ReactNode;
    rightNode?: React.ReactNode;
    placeholder?: string;
    disabled?: string | boolean;
    background?: string;
    type?: string;
}
export interface TextBoxProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface TextBoxState {
    hovered?: boolean;
    focused?: boolean;
}
export declare class TextBox extends React.Component<TextBoxProps, TextBoxState> {
    static defaultProps: TextBoxProps;
    state: TextBoxState;
    rootElm: HTMLDivElement;
    inputElm: HTMLInputElement;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    handleClick: (e?: React.MouseEvent<HTMLDivElement>) => void;
    handleHover: (e?: React.MouseEvent<HTMLDivElement>) => void;
    handleUnHover: (e?: React.MouseEvent<HTMLDivElement>) => void;
    handleFocus: (e?: React.FocusEvent<HTMLInputElement>) => void;
    handleBlur: (e?: React.FocusEvent<HTMLInputElement>) => void;
    setValue: (value: string) => string;
    getValue: () => string;
    render(): JSX.Element;
}
export default TextBox;
