/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import AddBlurEvent from "../common/AddBlurEvent";
import ListView from "../ListView";
export interface DataProps {
    defaultHour?: number;
    defaultMinute?: number;
    defaultShowPicker?: boolean;
    onChangeTime?: (hours?: number, minutes?: number) => void;
    inputItemHeight?: number;
    pickerItemHeight?: number;
    background?: string;
}
export interface TimePickerProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface TimePickerState {
    showPicker?: boolean;
    currHour?: number;
    currMinute?: number;
}
export declare class TimePicker extends React.Component<TimePickerProps, TimePickerState> {
    static defaultProps: TimePickerProps;
    state: TimePickerState;
    addBlurEvent: AddBlurEvent;
    rootElm: HTMLDivElement;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    prevState: {
        currHour: number;
        currMinute: number;
    };
    hourListView: ListView;
    minuteListView: ListView;
    timeTypeListView: ListView;
    hourIndex: number;
    minuteIndex: number;
    timeTypeIndex: number;
    componentWillReceiveProps(nextProps: TimePickerProps): void;
    addBlurEventMethod: () => void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    toggleShowPicker: (showPicker?: any) => void;
    render(): JSX.Element;
}
export default TimePicker;
