/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
import CustomAnimate from "../Animate/CustomAnimate";
export interface DataProps {
    defaultShow?: boolean;
    logoNode?: React.ReactNode;
    title?: string;
    description?: string | string[];
    closeDelay?: number;
    onToggleShowToast?: (showToast?: boolean) => void;
    showCloseIcon?: boolean;
}
export interface ToastProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface ToastState {
    showToast?: boolean;
}
export declare class Toast extends React.Component<ToastProps, ToastState> {
    static defaultProps: ToastProps;
    state: ToastState;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    toastID: number;
    hiddenTimer: any;
    closeTimer: any;
    customAnimate: CustomAnimate;
    customAnimateElm: HTMLDivElement;
    componentWillReceiveProps(nextProps: ToastProps): void;
    componentDidMount(): void;
    addCloseDelay: () => void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    toggleShowToast: (showToast?: any) => void;
    trueRender: () => JSX.Element;
    render(): any;
}
export default Toast;
