/// <reference types="react" />
import * as React from "react";
import * as PropTypes from "prop-types";
export interface DataProps {
    defaultToggled?: boolean;
    onToggle?: (isOpen?: boolean) => void;
    size?: number;
    label?: string;
    background?: string;
    checked?: boolean;
}
export interface ToggleProps extends DataProps, React.HTMLAttributes<HTMLDivElement> {
}
export interface ToggleState {
    currToggled?: boolean;
}
export declare class Toggle extends React.Component<ToggleProps, ToggleState> {
    static defaultProps: ToggleProps;
    state: ToggleState;
    static contextTypes: {
        theme: PropTypes.Requireable<any>;
    };
    context: {
        theme: ReactUWP.ThemeType;
    };
    componentWillReceiveProps(nextProps: ToggleProps): void;
    toggleToggle: (currToggled?: any) => void;
    render(): JSX.Element;
}
export default Toggle;
